# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['PineconeIndexArgs', 'PineconeIndex']

@pulumi.input_type
class PineconeIndexArgs:
    def __init__(__self__, *,
                 metric: pulumi.Input['IndexMetric'],
                 name: pulumi.Input[str],
                 spec: pulumi.Input['PineconeSpecArgs'],
                 dimension: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a PineconeIndex resource.
        :param pulumi.Input['IndexMetric'] metric: The metric used to compute the distance between vectors.
        :param pulumi.Input[str] name: The name of the Pinecone index.
        :param pulumi.Input['PineconeSpecArgs'] spec: Describe how the index should be deployed.
        :param pulumi.Input[int] dimension: The dimensions of the vectors in the index. Defaults to 1536.
        """
        pulumi.set(__self__, "metric", metric)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "spec", spec)
        if dimension is not None:
            pulumi.set(__self__, "dimension", dimension)

    @property
    @pulumi.getter
    def metric(self) -> pulumi.Input['IndexMetric']:
        """
        The metric used to compute the distance between vectors.
        """
        return pulumi.get(self, "metric")

    @metric.setter
    def metric(self, value: pulumi.Input['IndexMetric']):
        pulumi.set(self, "metric", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the Pinecone index.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def spec(self) -> pulumi.Input['PineconeSpecArgs']:
        """
        Describe how the index should be deployed.
        """
        return pulumi.get(self, "spec")

    @spec.setter
    def spec(self, value: pulumi.Input['PineconeSpecArgs']):
        pulumi.set(self, "spec", value)

    @property
    @pulumi.getter
    def dimension(self) -> Optional[pulumi.Input[int]]:
        """
        The dimensions of the vectors in the index. Defaults to 1536.
        """
        return pulumi.get(self, "dimension")

    @dimension.setter
    def dimension(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "dimension", value)


class PineconeIndex(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dimension: Optional[pulumi.Input[int]] = None,
                 metric: Optional[pulumi.Input['IndexMetric']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 spec: Optional[pulumi.Input[pulumi.InputType['PineconeSpecArgs']]] = None,
                 __props__=None):
        """
        Create a PineconeIndex resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] dimension: The dimensions of the vectors in the index. Defaults to 1536.
        :param pulumi.Input['IndexMetric'] metric: The metric used to compute the distance between vectors.
        :param pulumi.Input[str] name: The name of the Pinecone index.
        :param pulumi.Input[pulumi.InputType['PineconeSpecArgs']] spec: Describe how the index should be deployed.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PineconeIndexArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a PineconeIndex resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param PineconeIndexArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PineconeIndexArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dimension: Optional[pulumi.Input[int]] = None,
                 metric: Optional[pulumi.Input['IndexMetric']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 spec: Optional[pulumi.Input[pulumi.InputType['PineconeSpecArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PineconeIndexArgs.__new__(PineconeIndexArgs)

            __props__.__dict__["dimension"] = dimension
            if metric is None and not opts.urn:
                raise TypeError("Missing required property 'metric'")
            __props__.__dict__["metric"] = metric
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
            if spec is None and not opts.urn:
                raise TypeError("Missing required property 'spec'")
            __props__.__dict__["spec"] = spec
            __props__.__dict__["host"] = None
        super(PineconeIndex, __self__).__init__(
            'pinecone:index:PineconeIndex',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'PineconeIndex':
        """
        Get an existing PineconeIndex resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = PineconeIndexArgs.__new__(PineconeIndexArgs)

        __props__.__dict__["dimension"] = None
        __props__.__dict__["host"] = None
        __props__.__dict__["metric"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["spec"] = None
        return PineconeIndex(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def dimension(self) -> pulumi.Output[Optional[int]]:
        """
        The dimensions of the vectors in the index. Defaults to 1536.
        """
        return pulumi.get(self, "dimension")

    @property
    @pulumi.getter
    def host(self) -> pulumi.Output[str]:
        """
        The URL address where the index is hosted.
        """
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def metric(self) -> pulumi.Output['IndexMetric']:
        """
        The metric used to compute the distance between vectors.
        """
        return pulumi.get(self, "metric")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Pinecone index.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def spec(self) -> pulumi.Output['outputs.PineconeSpec']:
        """
        Describe how the index should be deployed.
        """
        return pulumi.get(self, "spec")

